Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class Font

    java.lang.Object
      |
      +--java.awt.Font

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  FontUIResource

public class Font
extends Object
implements Serializable

The `Font` class represents fonts. The capabilities of this class have been extended over the java.awt.Font class in JDK(tm) 1.1 and earlier releases to provide for developers the ability to utilize more sophisticated typographic features.

It is important to present the concepts behind using the words character and glyph separately. A character is a symbol that represents items like letters and numbers in a particular writing system. For example, lowercase-g is a character. When a particular character has been rendered, a shape now represents this character. This shape is called a glyph.

Chararcter encoding is a conversion table that maps character codes to glyph codes in the font. The character encoding used in the Java 2D(tm) API is Unicode. For more information on Unicode you can visit the site http://www.unicode.org.

Characters and glyphs do not have one-to-one correspondence. For example, lowercase-a acute can be represented by two glyphs: lowercase-a and acute. Another example is ligatures such as ligature -fi which is a single glyph representing two characters, f and i.

A `Font` is a collection of glyphs. A `Font` can have many faces, such as heavy, medium, oblique, gothic and regular. All of these faces have similar typographic design.

There are three different names that you can get from a `Font` object. The logical font name is the same as that used by java.awt.Font in JDK 1.1 and earlier releases. The font face name, or just font name for short, is the name of a particular font face, like Helvetica Bold. The family name is the name of the font family that determines the typographic design across several faces, like Helvetica. The font face name is the one that should be used to specify fonts. This name signifies actual fonts in the host system, and does not identify font names with the shape of font characters as the logical font name does.

The `Font` class represents an instance of a font face from a collection of font faces that are present in the system resources of the host system. As examples, Arial Bold and Courier Bold Italic are font faces. There can be several `Font` objects associated with a font face, each differing in size, style, transform and font features. The `getAllFonts` method of the `GraphicsEnvironment` class returns an array of all font faces available in the system. These font faces are returned as `Font` objects with a size of 1, identity transform and default font features. These base fonts can then be used to derive new `Font` objects with varying sizes, styles, transforms and font features via the `deriveFont` methods in this class.

See Also:
  `GraphicsEnvironment.getAllFonts()`, Serialized Form

Field Summary
`static int` | `BOLD` The bold style constant.
`static int` | `CENTER_BASELINE` The baseline used in ideographic scripts like Chinese, Japanese, and Korean when laying out text
`static int` | `HANGING_BASELINE` The baseline used in Devanigiri and similar scripts when laying out text
`static int` | `ITALIC` The italicized style constant.
`protected String` | `name` The logical name of this `Font`, as passed to the constructor.
`static int` | `PLAIN` The plain style constant.
`protected float` | `pointSize` The point size of this `Font` in `float`.
`static int` | `ROMAN_BASELINE` The baseline used in most Roman scripts when laying out text
`protected int` | `size` The point size of this `Font`, rounded to integer.
`protected int` | `style` The style of this `Font`, as passed to the constructor.
`static int` | `TRUETYPE_FONT` Create a Font of type TRUETYPE.

Constructor Summary
`Font(Map attributes)` Creates a new `Font` with the specified attributes.
`Font(String name, int style, int size)` Creates a new `Font` from the specified name, style and point size.

Method Summary
`boolean` | `canDisplay(char c)` Checks if this `Font` has a glyph for the specified character.
`int` | `canDisplayUpTo(char[] text, int start, int limit)` Indicates whether or not this `Font` can display the characters in the specified `text` starting at `start` and ending at `limit`.
`int` | `canDisplayUpTo(CharacterIterator iter, int start, int limit)` Indicates whether or not this `Font` can display the specified `String`.
`int` | `canDisplayUpTo(String str)` Indicates whether or not this `Font` can display a specified `String`.
`static Font` | `createFont(int fontFormat, InputStream fontStream)` Returns a new `Font` with the specified font type and input data.
`GlyphVector` | `createGlyphVector(FontRenderContext frc, char[] chars)` Returns a new `GlyphVector` object created with the specified array of characters and the specified `FontRenderContext`.
`GlyphVector` | `createGlyphVector(FontRenderContext frc, CharacterIterator ci)` Returns a new `GlyphVector` object created with the specified `CharacterIterator` and the specified `FontRenderContext`.
`GlyphVector` | `createGlyphVector(FontRenderContext frc, int[] glyphCodes)` Returns a new `GlyphVector` object created with the specified integer array and the specified `FontRenderContext`.
`GlyphVector` | `createGlyphVector(FontRenderContext frc, String str)` Returns a new `GlyphVector` object created with the specified `String` and the specified `FontRenderContext`.
`static Font` | `decode(String str)` Returns the `Font` that the `str` argument describes.
`Font` | `deriveFont(AffineTransform trans)` Creates a new `Font` object by replicating the current `Font` object and applying a new transform to it.
`Font` | `deriveFont(float size)` Creates a new `Font` object by replicating the current `Font` object and applying a new size to it.
`Font` | `deriveFont(int style)` Creates a new `Font` object by replicating the current `Font` object and applying a new style to it.
`Font` | `deriveFont(int style, AffineTransform trans)` Creates a new `Font` object by replicating this `Font` object and applying a new style and transform.
`Font` | `deriveFont(int style, float size)` Creates a new `Font` object by replicating this `Font` object and applying a new style and size.
`Font` | `deriveFont(Map attributes)` Creates a new `Font` object by replicating the current `Font` object and applying a new set of font attributes to it.
`boolean` | `equals(Object obj)` Compares this `Font` object to the specified `Object`.
`protected void` | `finalize()` Disposes the native `Font` object.
`Map` | `getAttributes()` Returns a map of font attributes available in this `Font`.
`AttributedCharacterIterator.Attribute[]` | `getAvailableAttributes()` Returns the keys of all the attributes supported by this `Font`.
`byte` | `getBaselineFor(char c)` Returns the baseline appropriate for displaying this character.
`String` | `getFamily()` Returns the family name of this `Font`.
`String` | `getFamily(Locale l)` Returns the family name of this `Font`, localized for the specified locale.
`static Font` | `getFont(Map attributes)` Returns a `Font` appropriate to this attribute set.
`static Font` | `getFont(String nm)` Returns a `Font` object from the system properties list.
`static Font` | `getFont(String nm, Font font)` Gets the specified `Font` from the system properties list.
`String` | `getFontName()` Returns the font face name of this `Font`.
`String` | `getFontName(Locale l)` Returns the font face name of the `Font`, localized for the specified locale.
`float` | `getItalicAngle()` Returns the italic angle of this `Font`.
`LineMetrics` | `getLineMetrics(char[] chars, int beginIndex, int limit, FontRenderContext frc)` Returns a `LineMetrics` object created with the specified arguments.
`LineMetrics` | `getLineMetrics(CharacterIterator ci, int beginIndex, int limit, FontRenderContext frc)` Returns a `LineMetrics` object created with the specified arguments.
`LineMetrics` | `getLineMetrics(String str, FontRenderContext frc)` Returns a `LineMetrics` object created with the specified `String` and `FontRenderContext`.
`LineMetrics` | `getLineMetrics(String str, int beginIndex, int limit, FontRenderContext frc)` Returns a `LineMetrics` object created with the specified arguments.
`Rectangle2D` | `getMaxCharBounds(FontRenderContext frc)` Returns the bounds for the character with the maximum bounds as defined in the specified `FontRenderContext`.
`int` | `getMissingGlyphCode()` Returns the glyphCode which is used when this `Font` does not have a glyph for a specified unicode.
`String` | `getName()` Returns the logical name of this `Font`.
`int` | `getNumGlyphs()` Returns the number of glyphs in this `Font`.
`java.awt.peer.FontPeer` | `getPeer()` Deprecated. Font rendering is now platform independent.
`String` | `getPSName()` Returns the postscript name of this `Font`.
`int` | `getSize()` Returns the point size of this `Font`, rounded to an integer.
`float` | `getSize2D()` Returns the point size of this `Font` in `float` value.
`Rectangle2D` | `getStringBounds(char[] chars, int beginIndex, int limit, FontRenderContext frc)` Returns the bounds of the specified array of characters in the specified `FontRenderContext`.
`Rectangle2D` | `getStringBounds(CharacterIterator ci, int beginIndex, int limit, FontRenderContext frc)` Returns the bounds of the characters indexed in the specified `CharacterIterator` in the specified `FontRenderContext`.
`Rectangle2D` | `getStringBounds(String str, FontRenderContext frc)` Returns the bounds of the specified `String` in the specified `FontRenderContext`.
`Rectangle2D` | `getStringBounds(String str, int beginIndex, int limit, FontRenderContext frc)` Returns the bounds of the specified `String` in the specified `FontRenderContext`.
`int` | `getStyle()` Returns the style of this `Font`.
`AffineTransform` | `getTransform()` Returns a copy of the transform associated with this `Font`.
`int` | `hashCode()` Returns a hashcode for this `Font`.
`boolean` | `hasUniformLineMetrics()` Checks whether or not this `Font` has uniform line metrics.
`boolean` | `isBold()` Indicates whether or not this `Font` object's style is BOLD.
`boolean` | `isItalic()` Indicates whether or not this `Font` object's style is ITALIC.
`boolean` | `isPlain()` Indicates whether or not this `Font` object's style is PLAIN.
`String` | `toString()` Converts this `Font` object to a `String` representation.

Methods inherited from class java.lang.Object
`clone, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### PLAIN

    public static final int PLAIN

  The plain style constant.

### BOLD

    public static final int BOLD

  The bold style constant. This can be combined with the other style constants (except PLAIN) for mixed styles.

### ITALIC

    public static final int ITALIC

  The italicized style constant. This can be combined with the other style constants (except PLAIN) for mixed styles.

### ROMAN_BASELINE

    public static final int ROMAN_BASELINE

  The baseline used in most Roman scripts when laying out text

### CENTER_BASELINE

    public static final int CENTER_BASELINE

  The baseline used in ideographic scripts like Chinese, Japanese, and Korean when laying out text

### HANGING_BASELINE

    public static final int HANGING_BASELINE

  The baseline used in Devanigiri and similar scripts when laying out text

### TRUETYPE_FONT

    public static final int TRUETYPE_FONT

  Create a Font of type TRUETYPE. In future other types may be added to support other font types.

### name

    protected String name

  The logical name of this `Font`, as passed to the constructor.
  See Also:
    `getName()`
  Since:
    JDK1.0

### style

    protected int style

  The style of this `Font`, as passed to the constructor. This style can be PLAIN, BOLD, ITALIC, or BOLD+ITALIC.
  See Also:
    `getStyle()`
  Since:
    JDK1.0

### size

    protected int size

  The point size of this `Font`, rounded to integer.
  See Also:
    `getSize()`
  Since:
    JDK1.0

### pointSize

    protected float pointSize

  The point size of this `Font` in `float`.
  See Also:
    `getSize()`, `getSize2D()`

Constructor Detail

### Font

    public Font(String name,
                int style,
                int size)

  Creates a new `Font` from the specified name, style and point size.
  Parameters:
    `name` - the font name. This can be a logical font name or a font face name. A logical name must be either: Dialog, DialogInput, Monospaced, Serif, SansSerif, or Symbol. If `name` is `null`, the `name` of the new `Font` is set to Default.
    `style` - the style constant for the `Font` The style argument is an integer bitmask that may be PLAIN, or a bitwise union of BOLD and/or ITALIC (for example, ITALIC or BOLD|ITALIC). Any other bits set in the style parameter are ignored. If the style argument does not conform to one of the expected integer bitmasks then the style is set to PLAIN.
    `size` - the point size of the `Font`
  Since:
    JDK1.0
  See Also:
    `GraphicsEnvironment.getAllFonts()`, `GraphicsEnvironment.getAvailableFontFamilyNames()`

### Font

    public Font(Map attributes)

  Creates a new `Font` with the specified attributes. This `Font` only recognizes keys defined in `TextAttribute` as attributes. If `attributes` is `null`, a new `Font` is initialized with default attributes.
  Parameters:
    `attributes` - the attributes to assign to the new `Font`, or `null`

Method Detail

### getPeer

    public java.awt.peer.FontPeer getPeer()

  Deprecated. Font rendering is now platform independent.

  Gets the peer of this `Font`.
  Returns:
    the peer of the `Font`.
  Since:
    JDK1.1

### getFont

    public static Font getFont(Map attributes)

  Returns a `Font` appropriate to this attribute set.
  Parameters:
    `attributes` - the attributes to assign to the new `Font`
  Returns:
    a new `Font` created with the specified attributes.
  Since:
    1.2

### createFont

    public static Font createFont(int fontFormat,
                                  InputStream fontStream)
                           throws FontFormatException,
                                  IOException

  Returns a new `Font` with the specified font type and input data. The new `Font` is created with a point size of 1 and style `PLAIN`. This base font can then be used with the `deriveFont` methods in this class to derive new `Font` objects with varying sizes, styles, transforms and font features. This method does not close the `InputStream`.
  Parameters:
    `fontType` - the type of the `Font`, which is `TRUETYPE_FONT` if a TrueType is desired. Other types might be provided in the future.
    `fontStream` - an `InputStream` object representing the input data for the font.
  Returns:
    a new `Font` created with the specified font type.
  Throws:
    `IllegalArgumentException` - if `fontType` is not `TRUETYPE_FONT`
    `FontFormatException` - if the `fontStream` data does not contain the required Truetype font tables.
    `IOException` - if the `fontStream` cannot be completely read.
  Since:
    1.3

### getTransform

    public AffineTransform getTransform()

  Returns a copy of the transform associated with this `Font`.
  Parameters:
    `an` - `AffineTransform` object representing the transform attribute of this `Font` object.

### getFamily

    public String getFamily()

  Returns the family name of this `Font`. For example, Helvetica could be returned as a family name for the font face name of Helvetica Bold. Use `getName` to get the logical name of the font. Use `getFontName` to get the font face name of the font.
  Returns:
    a `String` that is the family name of this `Font`.
  Since:
    JDK1.1
  See Also:
    `getName()`, `getFontName()`

### getFamily

    public String getFamily(Locale l)

  Returns the family name of this `Font`, localized for the specified locale. For example, Helvetica could be returned as a family name for the font face name of Helvetica Bold. Use `getFontName` to get the font face name of the font.
  Parameters:
    `l` - locale for which to get the family name
  Returns:
    a `String` representing the family name of the font, localized for the specified locale.
  Since:
    1.2
  See Also:
    `getFontName()`, `Locale`

### getPSName

    public String getPSName()

  Returns the postscript name of this `Font`. Use `getFamily` to get the family name of the font. Use `getFontName` to get the font face name of the font.
  Returns:
    a `String` representing the postscript name of this `Font`.
  Since:
    1.2

### getName

    public String getName()

  Returns the logical name of this `Font`. Use `getFamily` to get the family name of the font. Use `getFontName` to get the font face name of the font.
  Returns:
    a `String` representing the logical name of this `Font`.
  Since:
    JDK1.0
  See Also:
    `getFamily()`, `getFontName()`

### getFontName

    public String getFontName()

  Returns the font face name of this `Font`. For example, Helvetica Bold could be returned as a font face name. Use `getFamily` to get the family name of the font. Use `getName` to get the logical name of the font.
  Returns:
    a `String` representing the font face name of this `Font`.
  Since:
    1.2
  See Also:
    `getFamily()`, `getName()`

### getFontName

    public String getFontName(Locale l)

  Returns the font face name of the `Font`, localized for the specified locale. For example, Helvetica Fett could be returned as the font face name. Use `getFamily` to get the family name of the font.
  Parameters:
    `l` - a locale for which to get the font face name
  Returns:
    a `String` representing the font face name, localized for the specified locale.
  See Also:
    `getFamily()`, `Locale`

### getStyle

    public int getStyle()

  Returns the style of this `Font`. The style can be PLAIN, BOLD, ITALIC, or BOLD+ITALIC.
  Returns:
    the style of this `Font`
  Since:
    JDK1.0
  See Also:
    `isPlain()`, `isBold()`, `isItalic()`

### getSize

    public int getSize()

  Returns the point size of this `Font`, rounded to an integer. Most users are familiar with the idea of using point size to specify the size of glyphs in a font. This point size defines a measurement between the baseline of one line to the baseline of the following line in a single spaced text document. The point size is based on typographic points, approximately 1/72 of an inch.

  The Java(tm)2D API adopts the convention that one point is equivalent to one unit in user coordinates. When using a normalized transform for converting user space coordinates to device space coordinates 72 user space units equal 1 inch in device space. In this case one point is 1/72 of an inch.

  Returns:
    the point size of this `Font` in 1/72 of an inch units.
  Since:
    JDK1.0
  See Also:
    `getSize2D()`, `GraphicsConfiguration.getDefaultTransform()`, `GraphicsConfiguration.getNormalizingTransform()`

### getSize2D

    public float getSize2D()

  Returns the point size of this `Font` in `float` value.
  Returns:
    the point size of this `Font` as a `float` value.
  Since:
    1.2
  See Also:
    `getSize()`

### isPlain

    public boolean isPlain()

  Indicates whether or not this `Font` object's style is PLAIN.
  Returns:
    `true` if this `Font` has a PLAIN sytle; `false` otherwise.
  Since:
    JDK1.0
  See Also:
    `getStyle()`

### isBold

    public boolean isBold()

  Indicates whether or not this `Font` object's style is BOLD.
  Returns:
    `true` if this `Font` object's style is BOLD; `false` otherwise.
  Since:
    JDK1.0
  See Also:
    `getStyle()`

### isItalic

    public boolean isItalic()

  Indicates whether or not this `Font` object's style is ITALIC.
  Returns:
    `true` if this `Font` object's style is ITALIC; `false` otherwise.
  Since:
    JDK1.0
  See Also:
    `getStyle()`

### getFont

    public static Font getFont(String nm)

  Returns a `Font` object from the system properties list.
  Parameters:
    `nm` - the property name
  Returns:
    a `Font` object that the property name describes.
  Since:
    1.2

### decode

    public static Font decode(String str)

  Returns the `Font` that the `str` argument describes. To ensure that this method returns the desired Font, format the `str` parameter in one of two ways:

  "fontfamilyname-style-pointsize" or
  "fontfamilyname style pointsize"

  in which style is one of the three case-insensitive strings: `"BOLD"`, `"BOLDITALIC"`, or `"ITALIC"`, and pointsize is a decimal representation of the point size. For example, if you want a font that is Arial, bold, and a point size of 18, you would call this method with: "Arial-BOLD-18".

  The default size is 12 and the default style is PLAIN. If you don't specify a valid size, the returned `Font` has a size of 12. If you don't specify a valid style, the returned Font has a style of PLAIN. If you do not provide a valid font family name in the `str` argument, this method still returns a valid font with a family name of "dialog". To determine what font family names are available on your system, use the `GraphicsEnvironment.getAvailableFontFamilyNames()` method. If `str` is `null`, a new `Font` is returned with the family name "dialog", a size of 12 and a PLAIN style.

  Parameters:
    `str` - the name of the font, or `null`
  Returns:
    the `Font` object that `str` describes, or a new default `Font` if `str` is `null`.
  Since:
    JDK1.1
  See Also:
    `getFamily()`

### getFont

    public static Font getFont(String nm,
                               Font font)

  Gets the specified `Font` from the system properties list. As in the `getProperty` method of `System`, the first argument is treated as the name of a system property to be obtained. The `String` value of this property is then interpreted as a `Font` object.

  The property value should be one of the following forms:

  - fontname-style-pointsize
  - fontname-pointsize
  - fontname-style
  - fontname
  where style is one of the three case-insensitive strings `"BOLD"`, `"BOLDITALIC"`, or `"ITALIC"`, and point size is a decimal representation of the point size.

  The default style is `PLAIN`. The default point size is 12.

  If the specified property is not found, the `font` argument is returned instead.

  Parameters:
    `nm` - the case-insensitive property name
    `font` - a default `Font` to return if property `nm` is not defined
  Returns:
    the `Font` value of the property.
  See Also:
    `decode(String)`

### hashCode

    public int hashCode()

  Returns a hashcode for this `Font`.
  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hashcode value for this `Font`.
  Since:
    JDK1.0

### equals

    public boolean equals(Object obj)

  Compares this `Font` object to the specified `Object`.
  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - the `Object` to compare.
  Returns:
    `true` if the objects are the same; `false` otherwise.
  Since:
    JDK1.0

### toString

    public String toString()

  Converts this `Font` object to a `String` representation.
  Overrides:
    `toString` in class `Object`
  Returns:
    a `String` representation of this `Font` object.
  Since:
    JDK1.0

### getNumGlyphs

    public int getNumGlyphs()

  Returns the number of glyphs in this `Font`. Glyph codes for this `Font` range from 0 to `getNumGlyphs()` - 1.
  Returns:
    the number of glyphs in this `Font`.
  Since:
    1.2

### getMissingGlyphCode

    public int getMissingGlyphCode()

  Returns the glyphCode which is used when this `Font` does not have a glyph for a specified unicode.
  Returns:
    the glyphCode of this `Font`.
  Since:
    1.2

### getBaselineFor

    public byte getBaselineFor(char c)

  Returns the baseline appropriate for displaying this character.

  Large fonts can support different writing systems, and each system can use a different baseline. The character argument determines the writing system to use. Clients should not assume all characters use the same baseline.

  Parameters:
    `c` - a character used to identify the writing system
  Returns:
    the baseline appropriate for the specified character.
  Since:
    1.2
  See Also:
    `LineMetrics.getBaselineOffsets()`, `ROMAN_BASELINE`, `CENTER_BASELINE`, `HANGING_BASELINE`

### getAttributes

    public Map getAttributes()

  Returns a map of font attributes available in this `Font`. Attributes include things like ligatures and glyph substitution.
  Returns:
    the attributes map of this `Font`.

### getAvailableAttributes

    public AttributedCharacterIterator.Attribute[] getAvailableAttributes()

  Returns the keys of all the attributes supported by this `Font`. These attributes can be used to derive other fonts.
  Returns:
    an array containing the keys of all the attributes supported by this `Font`.
  Since:
    1.2

### deriveFont

    public Font deriveFont(int style,
                           float size)

  Creates a new `Font` object by replicating this `Font` object and applying a new style and size.
  Parameters:
    `style` - the style for the new `Font`
    `size` - the size for the new `Font`
  Returns:
    a new `Font` object.
  Since:
    1.2

### deriveFont

    public Font deriveFont(int style,
                           AffineTransform trans)

  Creates a new `Font` object by replicating this `Font` object and applying a new style and transform.
  Parameters:
    `style` - the style for the new `Font`
    `trans` - the `AffineTransform` associated with the new `Font`
  Returns:
    a new `Font` object.
  Throws:
    `IllegalArgumentException` - if `trans` is `null`
  Since:
    1.2

### deriveFont

    public Font deriveFont(float size)

  Creates a new `Font` object by replicating the current `Font` object and applying a new size to it.
  Parameters:
    `size` - the size for the new `Font`.
  Returns:
    a new `Font` object.
  Since:
    1.2

### deriveFont

    public Font deriveFont(AffineTransform trans)

  Creates a new `Font` object by replicating the current `Font` object and applying a new transform to it.
  Parameters:
    `trans` - the `AffineTransform` associated with the new `Font`
  Returns:
    a new `Font` object.
  Throws:
    `IllegalArgumentException` - if `trans` is `null`
  Since:
    1.2

### deriveFont

    public Font deriveFont(int style)

  Creates a new `Font` object by replicating the current `Font` object and applying a new style to it.
  Parameters:
    `style` - the style for the new `Font`
  Returns:
    a new `Font` object.
  Since:
    1.2

### deriveFont

    public Font deriveFont(Map attributes)

  Creates a new `Font` object by replicating the current `Font` object and applying a new set of font attributes to it.
  Parameters:
    `attributes` - a map of attributes enabled for the new `Font`
  Returns:
    a new `Font` object.
  Since:
    1.2

### canDisplay

    public boolean canDisplay(char c)

  Checks if this `Font` has a glyph for the specified character.
  Parameters:
    `c` - a unicode character code
  Returns:
    `true` if this `Font` can display the character; `false` otherwise.
  Since:
    1.2

### canDisplayUpTo

    public int canDisplayUpTo(String str)

  Indicates whether or not this `Font` can display a specified `String`. For strings with Unicode encoding, it is important to know if a particular font can display the string. This method returns an offset into the `String` `str` which is the first character this `Font` cannot display without using the missing glyph code. If the `Font` can display all characters, -1 is returned.
  Parameters:
    `str` - a `String` object
  Returns:
    an offset into `str` that points to the first character in `str` that this `Font` cannot display; or `-1` if this `Font` can display all characters in `str`.
  Since:
    1.2

### canDisplayUpTo

    public int canDisplayUpTo(char[] text,
                              int start,
                              int limit)

  Indicates whether or not this `Font` can display the characters in the specified `text` starting at `start` and ending at `limit`. This method is a convenience overload.
  Parameters:
    `text` - the specified array of characters
    `start` - the specified starting offset into the specified array of characters
    `limit` - the specified ending offset into the specified array of characters
  Since:
    1.2

### canDisplayUpTo

    public int canDisplayUpTo(CharacterIterator iter,
                              int start,
                              int limit)

  Indicates whether or not this `Font` can display the specified `String`. For strings with Unicode encoding, it is important to know if a particular font can display the string. This method returns an offset into the `String` `str` which is the first character this `Font` cannot display without using the missing glyph code . If this `Font` can display all characters, `-1` is returned.
  Parameters:
    `text` - a `CharacterIterator` object
    `start` - the specified starting offset into the specified array of characters
    `limit` - the specified ending offset into the specified array of characters
  Returns:
    an offset into the `String` object that can be displayed by this `Font`.
  Since:
    1.2

### getItalicAngle

    public float getItalicAngle()

  Returns the italic angle of this `Font`. The italic angle is the inverse slope of the caret which best matches the posture of this `Font`.
  Returns:
    the angle of the ITALIC style of this `Font`.
  See Also:
    `TextAttribute.POSTURE`

### hasUniformLineMetrics

    public boolean hasUniformLineMetrics()

  Checks whether or not this `Font` has uniform line metrics. A logical `Font` might be a composite font, which means that it is composed of different physical fonts to cover different code ranges. Each of these fonts might have different `LineMetrics`. If the logical `Font` is a single font then the metrics would be uniform.
  Returns:
    `true` if this `Font` has uniform line metrics; `false` otherwise.

### getLineMetrics

    public LineMetrics getLineMetrics(String str,
                                      FontRenderContext frc)

  Returns a `LineMetrics` object created with the specified `String` and `FontRenderContext`.
  Parameters:
    `str` - the specified `String`
    `frc` - the specified `FontRenderContext`
  Returns:
    a `LineMetrics` object created with the specified `String` and `FontRenderContext`.

### getLineMetrics

    public LineMetrics getLineMetrics(String str,
                                      int beginIndex,
                                      int limit,
                                      FontRenderContext frc)

  Returns a `LineMetrics` object created with the specified arguments.
  Parameters:
    `str` - the specified `String`
    `beginIndex` - the initial offset of `str`
    `limit` - the end offset of `str`
    `frc` - the specified `FontRenderContext`
  Returns:
    a `LineMetrics` object created with the specified arguments.

### getLineMetrics

    public LineMetrics getLineMetrics(char[] chars,
                                      int beginIndex,
                                      int limit,
                                      FontRenderContext frc)

  Returns a `LineMetrics` object created with the specified arguments.
  Parameters:
    `chars` - an array of characters
    `beginIndex` - the initial offset of `chars`
    `limit` - the end offset of `chars`
    `frc` - the specified `FontRenderContext`
  Returns:
    a `LineMetrics` object created with the specified arguments.

### getLineMetrics

    public LineMetrics getLineMetrics(CharacterIterator ci,
                                      int beginIndex,
                                      int limit,
                                      FontRenderContext frc)

  Returns a `LineMetrics` object created with the specified arguments.
  Parameters:
    `ci` - the specified `CharacterIterator`
    `beginIndex` - the initial offset in `ci`
    `limit` - the end offset of `ci`
    `frc` - the specified `FontRenderContext`
  Returns:
    a `LineMetrics` object created with the specified arguments.

### getStringBounds

    public Rectangle2D getStringBounds(String str,
                                       FontRenderContext frc)

  Returns the bounds of the specified `String` in the specified `FontRenderContext`. The bounds is used to layout the `String`.
  Parameters:
    `str` - the specified `String`
    `frc` - the specified `FontRenderContext`
  Returns:
    a `Rectangle2D` that is the bounding box of the specified `String` in the specified `FontRenderContext`.
  Since:
    1.2
  See Also:
    `FontRenderContext`, `createGlyphVector(java.awt.font.FontRenderContext, java.lang.String)`

### getStringBounds

    public Rectangle2D getStringBounds(String str,
                                       int beginIndex,
                                       int limit,
                                       FontRenderContext frc)

  Returns the bounds of the specified `String` in the specified `FontRenderContext`. The bounds is used to layout the `String`.
  Parameters:
    `str` - the specified `String`
    `beginIndex` - the initial offset of `str`
    `limit` - the end offset of `str`
    `frc` - the specified `FontRenderContext`
  Returns:
    a `Rectangle2D` that is the bounding box of the specified `String` in the specified `FontRenderContext`.
  Throws:
    `IndexOutOfBoundsException` - if `beginIndex` is less than zero, or `limit` is greater than the length of `str`, or `beginIndex` is greater than `limit`.
  Since:
    1.2
  See Also:
    `FontRenderContext`, `createGlyphVector(java.awt.font.FontRenderContext, java.lang.String)`

### getStringBounds

    public Rectangle2D getStringBounds(char[] chars,
                                       int beginIndex,
                                       int limit,
                                       FontRenderContext frc)

  Returns the bounds of the specified array of characters in the specified `FontRenderContext`. The bounds is used to layout the `String` created with the specified array of characters, `beginIndex` and `limit`.
  Parameters:
    `chars` - an array of characters
    `beginIndex` - the initial offset in the array of characters
    `limit` - the end offset in the array of characters
    `frc` - the specified `FontRenderContext`
  Returns:
    a `Rectangle2D` that is the bounding box of the specified array of characters in the specified `FontRenderContext`.
  Throws:
    `IndexOutOfBoundsException` - if `beginIndex` is less than zero, or `limit` is greater than the length of `chars`, or `beginIndex` is greater than `limit`.
  Since:
    1.2
  See Also:
    `FontRenderContext`, `createGlyphVector(java.awt.font.FontRenderContext, java.lang.String)`

### getStringBounds

    public Rectangle2D getStringBounds(CharacterIterator ci,
                                       int beginIndex,
                                       int limit,
                                       FontRenderContext frc)

  Returns the bounds of the characters indexed in the specified `CharacterIterator` in the specified `FontRenderContext`. The bounds is used to layout the `String`.
  Parameters:
    `ci` - the specified `CharacterIterator`
    `beginIndex` - the initial offset in `ci`
    `limit` - the end offset in `ci`
    `frc` - the specified `FontRenderContext`
  Returns:
    a `Rectangle2D` that is the bounding box of the characters indexed in the specified `CharacterIterator` in the specified `FontRenderContext`.
  Throws:
    `IndexOutOfBoundsException` - if `beginIndex` is less than the start index of `ci`, or `limit` is greater than the end index of `ci`, or `beginIndex` is greater than `limit`
  Since:
    1.2
  See Also:
    `FontRenderContext`, `createGlyphVector(java.awt.font.FontRenderContext, java.lang.String)`

### getMaxCharBounds

    public Rectangle2D getMaxCharBounds(FontRenderContext frc)

  Returns the bounds for the character with the maximum bounds as defined in the specified `FontRenderContext`.
  Parameters:
    `frc` - the specified `FontRenderContext`
  Returns:
    a `Rectangle2D` that is the bounding box for the character with the maximum bounds.

### createGlyphVector

    public GlyphVector createGlyphVector(FontRenderContext frc,
                                         String str)

  Returns a new `GlyphVector` object created with the specified `String` and the specified `FontRenderContext`.
  Parameters:
    `frc` - the specified `FontRenderContext`
    `str` - the specified `String`
  Returns:
    a new `GlyphVector` created with the specified `String` and the specified `FontRenderContext`.

### createGlyphVector

    public GlyphVector createGlyphVector(FontRenderContext frc,
                                         char[] chars)

  Returns a new `GlyphVector` object created with the specified array of characters and the specified `FontRenderContext`.
  Parameters:
    `frc` - the specified `FontRenderContext`
    `chars` - the specified array of characters
  Returns:
    a new `GlyphVector` created with the specified array of characters and the specified `FontRenderContext`.

### createGlyphVector

    public GlyphVector createGlyphVector(FontRenderContext frc,
                                         CharacterIterator ci)

  Returns a new `GlyphVector` object created with the specified `CharacterIterator` and the specified `FontRenderContext`.
  Parameters:
    `frc` - the specified `FontRenderContext`
    `ci` - the specified `CharacterIterator`
  Returns:
    a new `GlyphVector` created with the specified `CharacterIterator` and the specified `FontRenderContext`.

### createGlyphVector

    public GlyphVector createGlyphVector(FontRenderContext frc,
                                         int[] glyphCodes)

  Returns a new `GlyphVector` object created with the specified integer array and the specified `FontRenderContext`.
  Parameters:
    `frc` - the specified `FontRenderContext`
    `glyphcodes` - the specified integer array
  Returns:
    a new `GlyphVector` created with the specified integer array and the specified `FontRenderContext`.

### finalize

    protected void finalize()
                     throws Throwable

  Disposes the native `Font` object.
  Overrides:
    `finalize` in class `Object`
  Following copied from class: `java.lang.Object`
  Throws:
    `Throwable` - the `Exception` raised by this method

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.